def tri_par_comptage_petit(L: list[int]) -> list[int]:
    # On a la garanti que L[i] < 3 pour tout i
    c0 = 0
    c1 = 0
    c2 = 0
    for e in L:
        if e == 0:
            c0 += 1
        if e == 1:
            c1 += 1
        if e == 2:
            c2 += 1

    return [0]*c0 + [1]*c1 + [2]*c2

def tri_par_comptage(L: list[int]) -> list[int]:
    # On a la garanti que L[i] < len(L) pour tout i
    n = len(L)
    Compteurs = [0]*n 
    # Compteurs[i] représente le nombre de i dans la liste
    for e in L:
        Compteurs[e] += 1
    return [ i for i in range(n) for j in range(Compteurs[i]) ]
    # équivalent à 
    resultat = []
    for i in range(n):
        for j in range(Compteurs[i]):
            resultat.append(i)
    return resultat


def radix_tri(L: list[str]) -> list[str]:
    d = {} # lettre: list de chaine qui commençait par cette lettre
    for e in L:
        if e[0] not in d:
            d[e[0]] = []
        d[e[0]].append(e[1:])

    resultat = []
    for lettre, T in sorted(d.items(), key=lambda e:e[0]): # c'est un tri sur la première lettre
        for v in radix_tri(T):
            resultat.append(lettre + v) # on reconstruit le mot
    return resultat
    
